$debug
c
c
c       3DPS03 : Fils de 3DPSnoscreen.for
c	  trace Interactif d'un maillage
c       a partir d'un fichier ascii d'entre de L3D02.IN
c       et sortie postscript
c
c
c	Attension permutation circulaire des coordonnes
c
c	y->x, z->y, x->z
c	Axe des Z horizontal, 
c
c
c
	parameter (PI=3.1415926535)
	parameter (NPMAX=40000)
	character str*82, ligne*512,arg(20)*127 ,fileprn*40, switch*2
	logical vecteurs,visible,potential
	dimension XF(3,NPMAX),NCOTE(NPMAX),XSI(NPMAX),ETA(NPMAX)
	dimension XYZ(3,4),XSIAXE(4),ETAAXE(4),FA7(3,4),SOL(NPMAX)
	dimension xcm(4),xuser(4)
	common/trtrtr/  KOLOR(3)
	common/persp/ UX,UY,UZ, VX,VY,VZ, WX,WY,WZ, FX,FY,FZ, COM,SOM
	data XYZ / 3*0., 1.,0.,0., 0.,1.,0., 0.,0.,1. /
	data init / 0 / 
c
c
c	Lecture des options
c
	na = nargs()
	if(na.lt.2) then
	vecteurs=.false.
	else
	call getarg(1,switch,ncar)
	vecteurs = switch.eq.'/p'.or.switch.eq.'/P'.or.switch.eq.'/F'
	&          .or.switch.eq.'/f'
	potential = switch.eq.'/p'.or.switch.eq.'/P'
      endif
c	vecteurs = .true.
	
c
	write(*,'(''--- 3DPS03 ---'' )')
c
c
c
c       lecture du fichier resultat
c
c       1. Maillage
c
      open(2,file='l3D02.in',status='old')      
	npt=0
	read(2,*)
	read(2,*) nfa,idum,idum,idum

	do 20 ifa = 1,nfa
	read(2,*)ncote(ifa),
	&(XF(2,i),XF(3,i),XF(1,i),i= npt+1,npt+ncote(ifa))
	npt = npt + ncote(ifa)
	if(npt.gt.npmax) stop'Nombre de pts>NPMAX'
20    continue
	close(2)
c
c
c
c	calcul du sup de la distance
	
	xmax = xf(1,1)
	xmin = xf(1,1)
	do i=1,nfa
	do j=1,3
	if(xf(j,i).lt.xmin) xmin = xf(j,i)
	if(xf(j,i).gt.xmax) xmax = xf(j,i)
	enddo
	enddo

c
c       2. Lecture de la solution
c
	if(vecteurs) then
	open(2,file='L3D02.out')
	ligne =''
	do while (ligne.ne.' RESULTS')
	read(2,'(a)')ligne
c	write(*,*)ligne(1:30)
	enddo
	read(2,'(////)')

	i = 1
22	continue
	if(potential) then
	read(2,*,err=21)dum1,dum2,dum3,dum4,sol(i),dum6 ! potential
	else
	read(2,*,err=21)dum1,dum2,dum3,dum4,dum6,sol(i) ! flux
	endif
c	Write(*,*)dum1,dum2,dum3,dum4,sol(i),dum6
c	read(*,*)
      if(i.eq.1) then
	solmax = sol(1)
	solmin = sol(1)
	endif		
	if(sol(i).gt.solmax) solmax = sol(i)
	if(sol(i).lt.solmin) solmin = sol(i)
	i = i+1
	goto 22
21	nfa2 = i-1
	endif

	write(*,'('' Npt, nfa, nfa2 :'',3I5)')npt,nfa,nfa2
	write(*,'('' solmin, solmax :'',1p2e15.6)')solmin, solmax
c
c
c
c       initialisation des parametres de perspective
c
c
2       continue
	AX = 0.
	AY = 0.
	AZ = 0.
c
	D = 2.d0*(xmax-xmin)
c
	Th =  30./180.*Pi
	Ps =  50./180.*Pi
	Om =  0.
	zoom = 1.
	ncache = 0
	eex = .5

c	Modifs locales

	D = 5
	Th =  60./180.*Pi
	Ps =  60./180.*Pi

c
3     continue

c	Tridre au point de vue

	do i=1,4
	XYZ(1,i) = AX
	XYZ(2,i) = AY
	XYZ(3,i) = AZ
	enddo
	XYZ(1,2) = AX + 1
	XYZ(2,3) = AY + 1
	XYZ(3,4) = AZ +1

c
	call inipers(AX, AY, AZ, Ps, Th, Om, D)
c
c       premiere passe, calcul des extrema
c
	do 11 j=1,npt
c
	call T3D2D( XF(1,j),XF(2,j),XF(3,j),XSII,ETAI)
c 
	if(j.eq.1)then
c
	XSIMAX = XSII
	XSIMIN = XSII 
	ETAMAX = ETAI
	ETAMIN = ETAI
c
	else
c       
	XSIMAX = amax1(XSIMAX,XSII)
	XSIMIN = amin1(XSIMIN,XSII)
	ETAMAX = amax1(ETAMAX,ETAI)
	ETAMIN = amin1(ETAMIN,ETAI)
c
	endif
c
	XSI ( j ) = XSII
	ETA ( j ) = ETAI
c
c       write(*,'(2I5,2f10.5)')j,XSII,ETAI
11      continue

c       write(*,*)XSIMAX,XSIMIN,ETAMAX,ETAMIN
c
c       Calcul des axes
c
	do 13 i=1,4
c
	call T3D2D( XYZ(1,i),XYZ(2,i),XYZ(3,i),XSII,ETAI)
c 
	XSIMAX = amax1(XSIMAX,XSII)
	XSIMIN = amin1(XSIMIN,XSII)
	ETAMAX = amax1(ETAMAX,ETAI)
	ETAMIN = amin1(ETAMIN,ETAI)
c
	XSIAXE ( i ) = XSII
	ETAAXE ( i ) = ETAI
c
13      continue
c
c       Calcul des echelles
c
c
	ALX = XSIMAX - XSIMIN
	ALY = ETAMAX - ETAMIN
c
	EX = 638./ALX
	EY = 478./ALY
c
	E  = amin1 ( EX , EY )
	X0 = 320. - ( XSIMAX + XSIMIN )/2.*E
	Y0 = 240. + ( ETAMIN + ETAMAX )/2.*E
	write(*,'('' Trace postcript  '')')
c
c       Trace postscript
c
	if(init.eq.0) then
	init=1
c	write(*,'('' Fichier de sortie def=PRN : ''\)')
c	read(*,'(a)')fileprn
c	if(fileprn.eq.' ')fileprn='3DPS.PS'
      fileprn='3DPS.PS'
	endif

	open(10,file=fileprn,status='unknown')
c
	fact = 72./2.54
	call PSINIT( 1.*fact,1.*fact,18.*fact,28.*fact,10)
	write(10,*)'/B {0. setgray}def'
	write(10,*)'/G {.7 setgray}def'
	write(10,*)'/N {newpath}   def'
	write(10,*)'/M {moveto}    def'
	write(10,*)'/L {lineto}    def'
	write(10,*)'/C {closepath} def' 
	write(10,*)'/S {stroke}    def'
	write(10,*)'/K {gsave setrgbcolor fill grestore} def'
	write(10,*)'.25 setlinewidth B'
	write(10,*)'N 0 170 M 510 170 L 510 680 L 0 680 L C clip'

	XCM(1) = 9.*fact
	XCM(2) = 18.*fact
	XCM(3) = 15.*fact
	XCM(4) = 24.*fact

	ALX = XSIMAX - XSIMIN
	ALY = ETAMAX - ETAMIN
	AL  = amax1 ( ALX , ALY )
	xuser(1) = (XSIMAX + XSIMIN )/2. 
	xuser(2) = xuser(1) + AL/2.
	xuser(3) = (ETAMAX + ETAMIN )/2. 
	xuser(4) = xuser(3) + AL/2.

	call PSECHEL(xcm,xuser)

	ipt1 = 0
	ipt2 = 0

	do 32 ifa = 1,nfa
c
c       FA7 = coordonnees des extremites de la facette
c
	CX = 0.
	CY = 0. 
	CZ = 0.         

	do 35 i=1,NCOTE(ifa)

	ipt1 = ipt1 + 1
	CX = CX + XF(1,ipt1)
	CY = CY + XF(2,ipt1)
	CZ = CZ + XF(3,ipt1)    
	do 35 j=1,3
35    FA7(j,i) = XF(j,ipt1)

c
c       Calcul du centre et de la normale
c
	CX = CX/float(NCOTE(ifa))       
	CY = CY/float(NCOTE(ifa))       
	CZ = CZ/float(NCOTE(ifa))       
c
	X12 = FA7(1,2) - FA7(1,1)
	Y12 = FA7(2,2) - FA7(2,1)
	Z12 = FA7(3,2) - FA7(3,1)

	X23 = FA7(1,3) - FA7(1,2)
	Y23 = FA7(2,3) - FA7(2,2)
	Z23 = FA7(3,3) - FA7(3,2)

	SX = Y12 * Z23 - Z12 * Y23
	SY = Z12 * X23 - X12 * Z23
	SZ = X12 * Y23 - Y12 * X23

	aLS = sqrt(SX*SX+SY*SY+SZ*SZ)

	SX = SX/aLS
	SY = SY/aLS
	SZ = SZ/aLS     
c
c       test de visibilite
c
	XCFx = FX - CX
	XCFy = FY - CY
	XCFz = FZ - CZ
c
	Pvue = XCFx * SX + XCFy * SY + XCFz * SZ
c
	if ( Pvue . GT . 0. ) then 
	write(10,'('' B ''\)')
	else
	write(10,'('' G ''\)')
	endif
c
	do 34 ic = 1,NCOTE(ifa)
c
	ipt2 = ipt2 + 1
	X = XSI( ipt2 )*zoom 
	Y = ETA( ipt2 )*zoom 
c
	if ( ic.eq.1 ) then
c
c	premier point
c
	call VCVS ( X , Y , XI , YI , 0 )
	write(10,'('' N'',2f10.3,'' M''\)') XI,YI
	XD = X
	YD = Y
c
c       Fermeture de la facette et remplissage eventuel
c
	elseif ( ic . eq . ncote(ifa)) then

	call VCVS ( X , Y , XI , YI , 0 )
	write(10,'(2f10.3,'' L''\)') XI,YI

	if(vecteurs)then

	 if(ifa.le.nfa2) then

	a = (sol(ifa)-solmin)/(solmax-solmin)
	if(a.gt.1.d0)a=1.d0
	if(a.lt.0.d0)a=1.d-9
	a = a**(eex)
	call pallette (Ri, Gi, Bi, a)	
c	write(10,'('' C '',3f6.3,'' K S'')')Ri,Gi,Bi ! with wire
	write(10,'('' C '',3f6.3,'' K '')')Ri,Gi,Bi ! no wire

	 else
c	supprimer ici si pas de trac des facettes non colores

	write(10,'('' C S'')')
c	write(10,'('' C '')')
	
	 endif
	
      else
	 write(10,'('' C S'')')
	endif
	else
c
c	Point ordinaire
c
	call VCVS ( X , Y , XI , YI , 0 )
	write(10,'(2f10.3,'' L''\)') XI,YI

	endif
c
34      continue

32      continue
c
c       Trace des axes
c
	do 36 i = 1,4
c
	X = XSIAXE( i  )*zoom
	Y = ETAAXE( i  )*zoom 
c
	if (i.eq.1) then
	XX0 = X
	YY0 = Y
	else
c       call PSTRAS( XX0 , YY0 , 0 )    
c       call PSTRAS( X , Y , 1 )        
	call VCVS ( XX0 , YY0 , XI , YI , 0 )
	write(10,'('' N'',2f10.3,'' M''\)') XI,YI
	call VCVS ( X , Y , XI , YI , 0 )
	write(10,'(2f10.3,'' L S'')') XI,YI
	endif
36      continue
c
c
c	cartouche : code de couleurs
c
c
	if(vecteurs)then
	XC0 = XCM(1) + 0.7*(XCM(2)-XCM(1))
	YC0 = XCM(3)
	DXC = 0.2*(XCM(2)-XCM(1))/100
	DYC = 0.05*(XCM(4)-XCM(3))

	XC0 = 510 * .5 ! voir clip
	YC0 = 170
	DXC = 0.4*(510)/100.
	DYC = 0.03*(680-170)

	do i = 0,100
	a = dble(i)/100.
	a = a**(eex)
	write(10,'('' N '',2F10.3,'' M ''\)')XC0,YC0
	write(10,'(2F10.3, '' L ''\)')XC0+DXC,YC0
	write(10,'(2F10.3, '' L ''\)')XC0+DXC,YC0+DYC
	write(10,'(2F10.3, '' L ''\)')XC0,YC0+DYC
      call pallette (Ri, Gi, Bi, a)	
	write(10,'(''C'',3f6.3,'' K'')')Ri,Gi,Bi
	XC0 = XC0 + DXC
	enddo
	endif

	write(10,*)'showpage'
	if(fileprn.ne.'PRN'.and.fileprn.ne.'prn')then
	backspace 10
	read(10,'(a)')str
	endif
30      continue

	
     	write(*,'('' Dessin termin ''/)')
	call PSOUT
	close(10)
	
	write(*,'('' Modification perspective ''/)')
	write(*,'('' AX ='',f10.4,'' : ''\)')AX
	read(*,'(a)')str
	if(str.ne.' ')  call STRDE(str,15,AX,*1000)
c
	write(*,'('' AY ='',f10.4,'' : ''\)')AY
	read(*,'(a)')str
	if(str.ne.' ')  call STRDE(str,15,AY,*1000)

c
	write(*,'('' AZ ='',f10.4,'' : ''\)')AZ
	read(*,'(a)')str
	if(str.ne.' ')  call STRDE(str,15,AZ,*1000)

c
	write(*,'('' D  ='',f10.4,'' : ''\)')D
	read(*,'(a)')str
	if(str.ne.' ')  call STRDE(str,15,D,*1000)

c
	write(*,'('' Th ='',f10.4,'' : ''\)')th*180./pi
	read(*,'(a)')str
	if(str.ne.' ') then
	call STRDE(str,15,Th,*1000)
	Th = Th*pi/180.
	endif
c
	write(*,'('' Ps ='',f10.4,'' : ''\)')Ps*180./pi
	read(*,'(a)')str
	if(str.ne.' ') then
	call STRDE(str,15,Ps,*1000)
	Ps = Ps*pi/180.
	endif
c
	write(*,'('' Om ='',f10.4,'' : ''\)')Om*180./pi
	read(*,'(a)')str
	if(str.ne.' ') then
	call STRDE(str,15,Om,*1000)
	Om = Om*pi/180.
	endif
c
	write(*,'('' Zx ='',f10.4,'' : ''\)')zoom
	read(*,'(a)')str
	if(str.ne.' ') then
	call STRDE(str,15,zoom,*1000)
	endif
c
c	echelles vecteurs
c
	if(vecteurs) then
	
c
	write(*,'('' Ex ='',f10.4,'' : ''\)')eex
	read(*,'(a)')str
	if(str.ne.' ') then
	call STRDE(str,15,eex,*1000)
	endif

      write(*,'('' VECTEURS''/'' Min='',1pe10.3,'' : ''\)')solmin
	read(*,'(a)')str
	if(str.ne.' ') then
	call STRDE(str,15,solmin,*1000)
	endif

      write(*,'('' Max='',1pe10.3,'' : ''\)')solmax
	read(*,'(a)')str
	if(str.ne.' ') then
	call STRDE(str,15,solmax,*1000)
	endif

	endif	
c
c	write(*,'('' Parties cachees ='',I2,'' : ''\)')ncache
c	read(*,'(a)')str
c	if(str.ne.' ') then
c	call STRDJ(str,15,ncache,*1000)
c	endif
c
c	write(*,'('' Echelle vecteurs '',f10.1,'' : ''\)')scale
c	read(*,'(a)')str
c	if(str.ne.' ') then
c	call STRDE(str,15,scale,*1000)
c	endif
c
	goto 3  
c
1000    stop'ERREUR NON RECUPERABLE'
	end
$page
	subroutine inipers(AX,AY,AZ,Ps,Th,Om,D)
c
c       Initialisation de la perspective
c
	common/persp/ UX,UY,UZ, VX,VY,VZ, WX,WY,WZ, FX,FY,FZ, COM,SOM
c
	UX = sin(Ps) * cos(Th)
	UY = sin(Ps) * sin(Th)
	UZ = cos(Ps)
c
	VX =-sin(Th)
	VY = cos(Th) 
	VZ = 0.
c
	WX =-cos(Ps) * cos(Th)
	WY =-cos(Ps) * sin(Th)
	WZ = sin(Ps)
c
	FX = AX + ( D + 1. ) * UX       
	FY = AY + ( D + 1. ) * UY       
	FZ = AZ + ( D + 1. ) * UZ
	
      COM = cos(Om)
      SOM = sin(Om)       
c
	end
$page
	Subroutine T3D2D(X,Y,Z,XSI,ETA)
c
c       Transformation de coordonnees
c
	common/persp/ UX,UY,UZ, VX,VY,VZ, WX,WY,WZ, FX,FY,FZ, COM,SOM
c
	FMX = X - FX
	FMY = Y - FY
	FMZ = Z - FZ
c
	PU  = FMX * UX + FMY * UY + FMZ * UZ
	PV  = FMX * VX + FMY * VY + FMZ * VZ 
	PW  = FMX * WX + FMY * WY + FMZ * WZ
c
	XSI1 = - PV/PU
	ETA1 = - PW/PU
c
	XSI  =  XSI1*COM + ETA1*SOM
	ETA  = -XSI1*SOM + ETA1*COM
	 
	end

	subroutine pallette (Ri, Gi, Bi, a1)	

c	clip values to 0-1
c	Rouge-Jaune-bleu
	
	if(a1.lt.0.)then
	a=0.
	elseif(a1.gt.1.)then
	a=1.
	else
	a = a1
	endif
c
c	a = a**(1./2.)
c

      if (a.gt.2./3.) then

	Ri = 1
	Gi = 3*(1-a)
	Bi = 0

	elseif (a.gt.1./3.) then

	Ri = 3*a-1
	Gi = 1
	Bi = 0

	else

	Ri = 0
	Gi = 3*a
	Bi = 1-3*a
 
 	endif
	end
	subroutine xxxpallette (Ri, Gi, Bi, a1)	

c	clip values to 0-1
c	Rouge-Jaune-Vert
	
	if(a1.lt.0.)then
	a=0.
	elseif(a1.gt.1.)then
	a=1.
	else
	a = a1
	endif

	b = 1.- a

      if (a.lt..5) then

	Ri = 1.
	Gi = 2*a
	Bi = 0.

	else

	Ri = 2*b
	Gi = 1.
	Bi = 0.

	endif
	end

	subroutine yyypallette (Ri, Gi, Bi, a1)	

c	clip values to 0-1
c	Mauve-beluclai-bleu-fonc
	
	if(a1.lt.0.)then
	a=0.
	elseif(a1.gt.1.)then
	a=1.
	else
	a = a1
	endif

	b = 1.- a

      if (a.lt..5) then

	Ri = 0.
	Gi = 2*a
	Bi = 1.

	else

	Ri = 2.*(a-.5)
	Gi = 1.-Ri
	Bi = 1.

	endif
	end

