c
c     Calcul des facettes d'un cube pour calculer le potentiel
c     dans un cube par la methode des elements aux frontieres
c     domaine intrieur
c

      implicit real*8 (a-h,o-z)
      logical cube
	dimension XF(3,4,5500),XC(3,5500)

      Pi = 4.d0*datan(1.d0)

      N = 20
      cube = .false.
c      cube = .TRUE.
      
      OPEN(1,file='l3D02.in')

 	
      axe = 1.d0
      bxe = 1.d0
      nx = n
      ny = n
      nz = n

 	dx = 2.d0 * axe / nx
	dy = 2.d0 * axe / ny
	dz = 2.d0 * bxe / nz
	  
	ifa = 1  
c
c	face bas 
c
	zzz = -bxe 
	do 20 i = 1 , nx
	do 20 j = 1 , ny
	xxx = -axe + (i-1)*dx
	yyy = -axe + (j-1)*dy
c
	XF ( 1,1,ifa ) = xxx
	XF ( 2,1,ifa ) = yyy
	XF ( 3,1,ifa ) = zzz
c
	XF ( 1,2,ifa ) = xxx 
	XF ( 2,2,ifa ) = yyy + dy
	XF ( 3,2,ifa ) = zzz
c
	XF ( 1,3,ifa ) = xxx + dx
	XF ( 2,3,ifa ) = yyy + dy
	XF ( 3,3,ifa ) = zzz
c
	XF ( 1,4,ifa ) = xxx + dx
	XF ( 2,4,ifa ) = yyy
	XF ( 3,4,ifa ) = zzz
c
	ifa = ifa + 1
20	continue
c
c	face haut 
c
	zzz = +bxe 
	do 24 i = 1 , nx
	do 24 j = 1 , ny
	xxx = -axe + (i-1)*dx
	yyy = -axe + (j-1)*dy
c
	XF ( 1,1,ifa ) = xxx
	XF ( 2,1,ifa ) = yyy
	XF ( 3,1,ifa ) = zzz
c
	XF ( 1,2,ifa ) = xxx + dx
	XF ( 2,2,ifa ) = yyy 
	XF ( 3,2,ifa ) = zzz
c
	XF ( 1,3,ifa ) = xxx + dx
	XF ( 2,3,ifa ) = yyy + dy
	XF ( 3,3,ifa ) = zzz
c
	XF ( 1,4,ifa ) = xxx 
	XF ( 2,4,ifa ) = yyy + dy
	XF ( 3,4,ifa ) = zzz
c
	ifa = ifa + 1
24	continue
c
c	face derriere
c
	xxx = -axe 
	do 21 i = 1 , nz
	do 21 j = 1 , ny
	zzz = -bxe + (i-1)*dz
	yyy = -axe + (j-1)*dy
c
	XF ( 1,1,ifa ) = xxx
	XF ( 2,1,ifa ) = yyy
	XF ( 3,1,ifa ) = zzz
c
	XF ( 1,2,ifa ) = xxx 
	XF ( 2,2,ifa ) = yyy 
	XF ( 3,2,ifa ) = zzz + dz
c
	XF ( 1,3,ifa ) = xxx 
	XF ( 2,3,ifa ) = yyy + dy
	XF ( 3,3,ifa ) = zzz + dz
c
	XF ( 1,4,ifa ) = xxx 
	XF ( 2,4,ifa ) = yyy + dy
	XF ( 3,4,ifa ) = zzz
c
	ifa = ifa + 1
21	continue
c
c	face devant
c
	xxx = +axe 
	do 25 i = 1 , nz
	do 25 j = 1 , ny
	zzz = -bxe + (i-1)*dz
	yyy = -axe + (j-1)*dy
c
	XF ( 1,1,ifa ) = xxx
	XF ( 2,1,ifa ) = yyy
	XF ( 3,1,ifa ) = zzz
c
	XF ( 1,2,ifa ) = xxx 
	XF ( 2,2,ifa ) = yyy + dy
	XF ( 3,2,ifa ) = zzz 
c
	XF ( 1,3,ifa ) = xxx 
	XF ( 2,3,ifa ) = yyy + dy
	XF ( 3,3,ifa ) = zzz + dz
c
	XF ( 1,4,ifa ) = xxx 
	XF ( 2,4,ifa ) = yyy 
	XF ( 3,4,ifa ) = zzz + dz
c
	ifa = ifa + 1
25	continue
c
c	face gauche 
c
	yyy = -axe 
	do 22 i = 1 , nz
	do 22 j = 1 , nx
	zzz = -bxe + (i-1)*dz
	xxx = -axe + (j-1)*dx
c
	XF ( 1,1,ifa ) = xxx
	XF ( 2,1,ifa ) = yyy
	XF ( 3,1,ifa ) = zzz
c
	XF ( 1,2,ifa ) = xxx + dx
	XF ( 2,2,ifa ) = yyy 
	XF ( 3,2,ifa ) = zzz 
c
	XF ( 1,3,ifa ) = xxx + dx
	XF ( 2,3,ifa ) = yyy 
	XF ( 3,3,ifa ) = zzz + dz
c
	XF ( 1,4,ifa ) = xxx 
	XF ( 2,4,ifa ) = yyy 
	XF ( 3,4,ifa ) = zzz + dz
c
	ifa = ifa + 1
22	continue
c
c	face droite
c
	yyy = +axe 
	do 26 i = 1 , nz
	do 26 j = 1 , nx
	zzz = -bxe + (i-1)*dz
	xxx = -axe + (j-1)*dx
c
	XF ( 1,1,ifa ) = xxx
	XF ( 2,1,ifa ) = yyy
	XF ( 3,1,ifa ) = zzz
c
	XF ( 1,2,ifa ) = xxx 
	XF ( 2,2,ifa ) = yyy 
	XF ( 3,2,ifa ) = zzz + dz
c
	XF ( 1,3,ifa ) = xxx + dx
	XF ( 2,3,ifa ) = yyy 
	XF ( 3,3,ifa ) = zzz + dz
c
	XF ( 1,4,ifa ) = xxx + dx
	XF ( 2,4,ifa ) = yyy 
	XF ( 3,4,ifa ) = zzz
c
	ifa = ifa + 1
26	continue

      nfa = ifa-1


c	projection sur l'ellipsoide

      if(.not.cube)then
      
	do 23 i = 1 , nfa
	do 23 ic = 1 , 4
c
	call PSCAL ( XF(1,ic,i) , XF(1,ic,i) , Xlong )
	Xlong = dsqrt ( Xlong )
c
	Ylong = XF(1,ic,i)**2 + XF(2,ic,i)**2
	Ylong = dsqrt(Ylong)
c
	acps = dmax1 ( -1.d0, XF ( 3,ic,i ) / Xlong)
	acps = dmin1 (  1.d0, XF ( 3,ic,i ) / Xlong)
	ps = dacos ( acps )
c
	if( Ylong .gt. 0.d0) then
	acth = dmax1 ( -1.d0, XF ( 1,ic,i ) / Ylong)
	acth = dmin1 (  1.d0, XF ( 1,ic,i ) / Ylong)
	th = dacos ( XF ( 1,ic,i ) / Ylong)
	else
	th = 0.d0
	endif
c
	if ( XF ( 2,ic,i ) .lt. 0.d0 ) th = 2.d0*pi - th  
c
	XF ( 1,ic,i ) = axe * dsin (ps) * dcos(th)
	XF ( 2,ic,i ) = axe * dsin (ps) * dsin(th)
	XF ( 3,ic,i ) = bxe * dcos (ps)
c
23	continue

      endif
c
c
c	Calcul des centres
c
c
	do 28 i = 1,nfa
	do 27 k = 1,3
c
	XC(k,i)  = .25d0 * (  XF(k,4,i) + XF(k,3,i) 	
     *	                    +XF(k,2,i) + XF(k,1,i) ) 
27	continue
28    continue


c     Ecriture du jeu de donnes

      WRITE(1,*)'Maillage d''un cube/sphere pour le potentiel intrieur'   
      WRITE(1,*)Nfa,0,0,0,0


      do i=1,nfa
      write(1,'(i4,12f20.12)')4,((XF(k,j,i),k=1,3),j=1,4)
      enddo
      
      do i=1,nfa
c      if(XC(3,i).gt..999.or.XC(3,i).lt.-.999) then    
c      icode = 0
c      else
c      icode = 1
c      endif
      
      icode = 0      
      v  = VS(XC(1,i),XC(2,i),XC(3,i))
      write(1,'(i5,f20.12)')icode,v
      enddo
      
      END

      FUNCTION VS(x,y,z)

       implicit real*8(a-h,o-z)
     
c        VS=DSQRT(x*x+y*y+z*z)
         VS=x*x+y*y-2*z*z
c         Vs = Z      
c      if(z.gt..999) then 
c      Vs = 1
c      elseif(z.lt.-.999) then
c      Vs = -1.
c      else
c      Vs = 0.
c      endif

       END

      FUNCTION DVSDN(x,y,z,xn,yn,zn)

       implicit real*8(a-h,o-z)

       DVSDN=2*x*xn+2*y*yn-4*z*zn
c        DVSDN=zn
  
       END
	subroutine PSCAL ( X , Y , Z )
c
c
c	Produit scalaire : Z = X . Y
c
c
      implicit real*8 (a-h,o-z)
	dimension X(1) , Y(1) 
c
	Z   = X(1) * Y(1) + X(2) * Y(2) + X(3) * Y(3)
c
	end 
    
